#include <iostream>
#include <fstream>
#include <string> 
#include <math.h>
#include <stdexcept>

using namespace std;

using funkce = double(*)(double);

void kontrola(funkce f, double od, double po, int kolik)
{
	if (!f)
	{
		throw invalid_argument("Przdn ukazatel na tabelovanou funkci");
	}
	if (kolik <= 0) 
	{
		throw invalid_argument("Nekladn poet poadovanch hodnot");
	}
	if ((kolik == 1) && (od != po))
	{
		throw invalid_argument("Poadovna jedin hodnota v intervalu nenulov dlky");
	}
}

void zahlavi(string jmeno)
{
	cout << "Tabulka funkce " << jmeno << endl
		 << "------------------" << endl
		 << "x            " << jmeno << endl
		 << "------------------" << endl;
}


void tabulka(funkce f, string jmeno, double od, double po, int kolik)
{
	kontrola(f, od, po, kolik);
	double krok = kolik == 1 ? 0 : (po - od) / (kolik - 1);
	zahlavi(jmeno);
	for (int i = 0; i < kolik; i++)
	{
		double x = od + i*krok;
		cout << x << "         " << f(x) << endl;
	}
}

int main()
{
	try
	{
		tabulka([](double x)->double {return x*x; }, "x^2", 1000, 1010, 11);
		cout << "--------------" << endl;
		tabulka(sin, "sin(x)", 0, 1, 11);

	}
	catch (invalid_argument e)
	{
		cerr << e.what() << endl;
	}
}

