#include <stdlib.h>
#include <stdexcept>
#include "volba.h"
#include "znaky.h"
#include "komparatory.h"

string volba::text_napovedy = retezec_Cp1250_na_string_Cp852(R"(
SORT - program pro seazen dek danho souboru. Pouit:
sort volba < vstupn-soubor > vstupn-soubor
Mon volby:
-n nebo /n     azen podle sel na potcch dek
-l nebo /l     lexikografick azen
-a nebo /a     abecedn azen

(C) Pikvorky software 2017
)");


volba::volba(int argc, char **argv)
{
	try
	{
		if (argc != 2)
		{
			throw runtime_error("patn poet parametr");
		}
		if (argv[1][0] == '/')
		{
			argv[1][0] = '-';
		}
		komparator = tabulka_voleb.at(argv[1]);
	}
	catch (exception &e)
	{
		napoveda();
	}
}

void volba::napoveda()
{
	cerr << text_napovedy << endl;
	exit(1);
}

volba::u_komparator volba::zvoleno()
{
	return komparator;
}

map<string, volba::u_komparator> volba::tabulka_voleb{
	{"-l", lexikograficky},
	{"-n", podle_cisel},
    {"-a", abecedne },
};


