#include <locale>
#include <stdexcept>
#include <stdlib.h>
#include "volba.h"
#include "znaky.h"
#include "komparatory.h"
#include "inicializace.h"

string volba::zalozni_text_napovedy = retezec_Cp1250_na_string_Cp852(R"(
SORT - program pro seazen dek danho souboru. Pouit:
sort volba < vstupn-soubor > vstupn-soubor
Mon volby:
-n nebo /n     azen podle sel na potcch dek
-l nebo /l     lexikografick azen
-a nebo /a     abecedn azen

Tyto volby uruj vzestupn azen. Pro sestupn azen
pipojte za volbu znak o (nap. -lo zpsob sestupn
lexikografick azen).

(C) Pikvorky software 2017
)");


map<string, volba::u_komparator> volba::tabulka_voleb{
	{ "-l", lexikograficky },
	{ "-n", podle_cisel },
	{ "-a", abecedne },
	{ "-lo", negace<lexikograficky> },
	{ "-no", negace<podle_cisel> },
	{ "-ao", negace<abecedne> }
};

volba::volba(int argc, char ** argv)
{
	try
	{
		if (argc != 2)
		{
			throw runtime_error("patn poet parametr");
		}
		if (argv[1][0] == '/')
		{
			argv[1][0] = '-';
		}
		komparator = tabulka_voleb.at(argv[1]);
	}
	catch (exception &e)
	{
		nacti_napovedu();
		napoveda();
	}
}

void volba::nacti_napovedu()
{
	try
	{
		string text_pom;
		inicializator.nacti_text("[npovda]", text_pom);
		text_napovedy = string_Cp1250_na_string_Cp852(text_pom);
	}
	catch (runtime_error e)
	{
		text_napovedy = zalozni_text_napovedy;
	}
}



void volba::napoveda()
{
	cerr << text_napovedy << endl;
	exit(1);
}

volba::u_komparator volba::zvoleno()
{
	return komparator;
}


